//a photobooth app that posts to twitter

//variables for video and canvas frame to post
var img;
var video;

let frames = [];

//setup Twitter stuff -codebird.js
var consumerKey = "XqG77cbGvWfNzD7mwK1vkrfFU";
var consumerSecret = "e8IdiJSuvYOclGvIR4kgb0R5jISvc2YPUn7rq7slhPFJCEAd2W";

var token = "805832107973033984-7afE7AWCFfG6FElfmUcF5pr7qVlHVmK";
var tokenSecret = "tDAoA3Xai627fFRru51VBImnAUD1B02qqF6eqLc9NYLEr";

var cb = new Codebird();

var videoScale = 16;

// Number of columns and rows in our system
var cols, rows;

function setup() {
  createCanvas(640, 480);

  // Initialize columns and rows
  cols = width/videoScale;
  rows = height/videoScale;

  pixelDensity(1);
  video = createCapture(VIDEO);
  video.parent('canvasDiv')
  video.size(cols, rows);
  //video.hide();
    
  //setup twitter
  cb.setConsumerKey(consumerKey, consumerSecret);
  cb.setToken(token, tokenSecret);
    
    //buttons for video controls
  var button = createButton('snap');
  button.class('interface');
  button.parent('buttonInterface');
  button.mousePressed(savetheframes);
    
    var button2 = createButton('post');
    button2.class('interface');
    button2.parent('buttonInterface');
    button2.mousePressed(postTheImage);
}

function draw() {
    //do something more interesting than just posting the video to the canvas
  video.loadPixels();
    //the code below creates a grid, using the data coming from the pixel values in the video and draws a gridded version of these to the canvas
  // Begin loop for columns
  for (var i = 0; i < cols; i++) {
    // Begin loop for rows
    for (var j = 0; j < rows; j++) {
      // Scaling up to draw a rectangle at (x,y)
      var loc = (i + j * cols) * 4;
      // The functions red(), green(), and blue() pull out the three color components from a pixel.
      var r = video.pixels[loc   ]; 
      var g = video.pixels[loc + 1];
      var b = video.pixels[loc + 2];
      fill(r,g,b);
      stroke(0);
      // For every column and row, a rectangle is drawn at an (x,y) location scaled and sized by videoScale.
      var x = i*videoScale;
      var y = j*videoScale;
      rect(x, y, videoScale, videoScale);
    }
  }
}

function savetheframes(){
        //save the frames
        console.log('saving');
        saveFrames('out', 'png', 4, 4, gotData);//change this up to get different frames
}

function gotData(data){
   // console.log(data);
    //frames are just here.  We can console.log them but need a server to save
    //console.log(data[0].imageData);
    //what does this look like
    console.log(data);
    //grab just the first image?
    var rawImage = data[0].imageData;
    //this saves a long string with a header
    //split that to just get the actual base-64 encoded string
    var imgStringArray = rawImage.split(',');
    //this generates an array
    //save the image, will be the second thing in the array at index 1.  Index 0 holds the header
    img = imgStringArray[1];
    //what does that look like?
    console.log(imgStringArray[1]);
    
    
        //what if we want to display more of these?
        /*//save an array of these.
        for(var i=0;i<data.length;i++){
            //push the frames to the frames array, reset the array each time we snap
            frames = [];
            var thisRawImage = data[i].imageData;

            //push to the array of frames
            frames.push(thisRawImage);
        }*/
    
        //now, go through the array of frames
        /*for(var i=0;i<frames.length;i+=2){
            var imgTag = createImg(frames[i]);
            imgTag.size(160,120);
            imgTag.parent('photoReel');
        }*/
    
    
    //append image to the page
    var imgTag = createImg(rawImage);
    imgTag.size(160,120);
    //createP(imgStringArray[1]);
    

           
}//end gotData

function postTheImage(){
    var params = {"media_data": img}
    cb.__call(
    "media_upload",
    params,
    function(reply,rate,err){
        if(err){
            console.log(err);
        }else{
            console.log(reply);
            mediaString = reply.media_id_string;
            cb.__call("statuses_update", {
                media_ids: mediaString,
                status: "it posted"
            }, function(reply,rate,err){
                if(err){
                    console.log(err);
                } else {
                    console.log(reply);
                }
            });
        }
    });
}

